package com.ruoyi.dimp.service.impl;

import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.List;
import java.util.Objects;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.utils.DateUtils;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.file.FileUploadUtils;
import com.ruoyi.dimp.mapper.DHighValueInfoPreImpMapper;
import com.ruoyi.dimp.mapper.DPatentAuthInfoPreImpMapper;
import com.ruoyi.dimp.domain.DHighValueInfoPreImp;
import com.ruoyi.dimp.domain.DPatentAuthInfoPreImp;
import com.ruoyi.dimp.service.IDPatentAuthInfoPreImpService;

/**
 * 专利授权导入记录Service业务层处理
 *
 * @author ruoyi
 * @date 2023-03-19
 */
@Service
public class DPatentAuthInfoPreImpServiceImpl extends ServiceImpl<DPatentAuthInfoPreImpMapper, DPatentAuthInfoPreImp> implements IDPatentAuthInfoPreImpService {

	private static final Logger logger = LoggerFactory.getLogger(DPatentAuthInfoPreImpServiceImpl.class);

	@Autowired
	private RuoYiConfig ruoYiConfig;
	@Autowired
	private DPatentAuthInfoPreImpMapper dPatentAuthInfoPreImpMapper;
	
	public String getImpPath() {
		return ruoYiConfig.getProfile() + "/DPatentAuthInfoPreImp";
	}

	
	public DPatentAuthInfoPreImp importData(MultipartFile file,String impBatch) {
		DPatentAuthInfoPreImp imp = new DPatentAuthInfoPreImp();
		try {
			String impres = FileUploadUtils.upload(getImpPath(), file);

			impres = impres.substring(Constants.RESOURCE_PREFIX.length());
			impres = RuoYiConfig.getProfile() + impres;

			imp.setFilePath(impres);
			
			String filePath = impres;
			File path = new File(filePath).getParentFile();
			
			String fileName = new File(impres).getName();
			
			String resFileName = fileName.substring(0, fileName.lastIndexOf(".")) + ""
					+ fileName.substring(fileName.lastIndexOf("."), fileName.length());
			
			int dirLastIndex = RuoYiConfig.getProfile().length() + 1;
			String currentDir = StringUtils.substring(path.getAbsolutePath(), dirLastIndex);
			String res = Constants.RESOURCE_PREFIX + "/" + currentDir + "/" + resFileName;

			imp.setFileUrl(ruoYiConfig.getFilePath() + res);
			
			imp.setPreImpTime(new Date());
			imp.setFileName(fileName);
			imp.setImpState("0");//
			imp.setDataSrc("Web导入");
			imp.setInsertNum(0L);
			imp.setSkipNum(0L);
			imp.setUpdateNum(0L);
			imp.setErrorNum(0L);
			imp.setErrReason("系统已接收");
			imp.setImpBatch(impBatch);
			dPatentAuthInfoPreImpMapper.insert(imp);

		} catch (IOException e) {
			logger.error("高价值数据导入失败," + e.getMessage(), e);
			String res = "导入失败，原因:" + e.getMessage();
			imp.setErrReason(res);
		}

		return imp;
	}
	
    /**
     * 查询专利授权导入记录列表
     *
     * @param dPatentAuthInfoPreImp 专利授权导入记录
     * @return 专利授权导入记录集合
     * @date 2023-03-19
     */
    @Override
    public List<DPatentAuthInfoPreImp> queryList(DPatentAuthInfoPreImp dPatentAuthInfoPreImp) {
        QueryWrapper<DPatentAuthInfoPreImp> queryWrapper = Wrappers.query();
                if (  StringUtils.isNotNull(dPatentAuthInfoPreImp.getPreImpTime())){
                    queryWrapper.eq("pre_imp_time", dPatentAuthInfoPreImp.getPreImpTime());
                }
                if ( StringUtils.isNotEmpty(dPatentAuthInfoPreImp.getFileName())  ){
                    queryWrapper.like("file_name", dPatentAuthInfoPreImp.getFileName());
                }
                if ( StringUtils.isNotEmpty(dPatentAuthInfoPreImp.getFileUrl())  ){
                    queryWrapper.eq("file_url", dPatentAuthInfoPreImp.getFileUrl());
                }
                if ( StringUtils.isNotEmpty(dPatentAuthInfoPreImp.getImpState())  ){
                    queryWrapper.eq("imp_state", dPatentAuthInfoPreImp.getImpState());
                }
                if ( StringUtils.isNotEmpty(dPatentAuthInfoPreImp.getTenantNo())  ){
                    queryWrapper.eq("tenant_no", dPatentAuthInfoPreImp.getTenantNo());
                }
                if (  StringUtils.isNotNull(dPatentAuthInfoPreImp.getInsertNum())){
                    queryWrapper.eq("insert_num", dPatentAuthInfoPreImp.getInsertNum());
                }
                if (  StringUtils.isNotNull(dPatentAuthInfoPreImp.getUpdateNum())){
                    queryWrapper.eq("update_num", dPatentAuthInfoPreImp.getUpdateNum());
                }
                if (  StringUtils.isNotNull(dPatentAuthInfoPreImp.getSkipNum())){
                    queryWrapper.eq("skip_num", dPatentAuthInfoPreImp.getSkipNum());
                }
                if (  StringUtils.isNotNull(dPatentAuthInfoPreImp.getErrorNum())){
                    queryWrapper.eq("error_num", dPatentAuthInfoPreImp.getErrorNum());
                }
                if ( StringUtils.isNotEmpty(dPatentAuthInfoPreImp.getDataSrc())  ){
                    queryWrapper.eq("data_src", dPatentAuthInfoPreImp.getDataSrc());
                }
                if ( StringUtils.isNotEmpty(dPatentAuthInfoPreImp.getErrReason())  ){
                    queryWrapper.eq("err_reason", dPatentAuthInfoPreImp.getErrReason());
                }
                if ( StringUtils.isNotEmpty(dPatentAuthInfoPreImp.getResFileName())  ){
                    queryWrapper.like("res_file_name", dPatentAuthInfoPreImp.getResFileName());
                }
                if ( StringUtils.isNotEmpty(dPatentAuthInfoPreImp.getResFileUrl())  ){
                    queryWrapper.eq("res_file_url", dPatentAuthInfoPreImp.getResFileUrl());
                }
        queryWrapper.orderByDesc("id");
        return this.list(queryWrapper);
    }
}
